OBCisTransStereo Class Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Member Functions | Static Public Member Functions | Protected Attributes
OBCisTransStereo Class Reference
Stereochemistry

`#include <openbabel/stereo/cistrans.h>`

Inheritance diagram for OBCisTransStereo:
[legend]

List of all members.

## Classes
struct | Config
| Stereochemical configuration for double-bond cis/trans stereochemistry. More...
## Public Member Functions
| OBCisTransStereo (OBMol *mol)
virtual | ~OBCisTransStereo ()
OBGenericData * | Clone (OBBase *mol) const
void | SetAttribute (const std::string &v)
void | SetOrigin (const DataOrigin s)
virtual const std::string & | GetAttribute () const
unsigned int | GetDataType () const
virtual const std::string & | GetValue () const
virtual DataOrigin | GetOrigin () const
Cis/Trans stereochemistry
OBStereo::Type | GetType () const
bool | IsValid () const
void | SetConfig (const Config &config)
Config | GetConfig (OBStereo::Shape shape=OBStereo::ShapeU) const
Config | GetConfig (unsigned long start, OBStereo::Shape shape=OBStereo::ShapeU) const
bool | operator== (const OBCisTransStereo &other) const
bool | operator!= (const OBCisTransStereo &other) const
Query methods to compare stereochemistry.
bool | IsOnSameAtom (unsigned long id1, unsigned long id2) const
bool | IsTrans (unsigned long id1, unsigned long id2) const
bool | IsCis (unsigned long id1, unsigned long id2) const
unsigned long | GetTransRef (unsigned long id) const
unsigned long | GetCisRef (unsigned long id) const
Geniric (for all OBStereo::Type) stereochemistry
OBMol * | GetMolecule () const
void | SetSpecified (bool specified)
bool | IsSpecified () const
## Static Public Member Functions
template<typename ConfigType >
static ConfigType | ToConfig (const ConfigType &cfg, unsigned long start, OBStereo::Shape shape=OBStereo::ShapeU)
## Protected Attributes
std::string | _attr
unsigned int | _type
DataOrigin | _source

## Detailed Description

Class for handling and storing cis/trans stereochemistry.

The OBCisTransStereo class is used to represent cis/trans stereochemistry. Like all OBTetraPlanarStereo subclasses, it uses the OBStereo::Shape parameters to set/get the OBStereo::Ref values in the Config struct. However, since the orientation of the double bond matters, all methods in the "query methods" section check the bonding by actually checking the atoms in the molecule provided through OBStereoBase's constructor. If OBMol::GetAtomById(id) returns 0 for a single id, it will be considered a deleted or implicit hydrogen if the valences confirm this.

The use of OBStereo::Shape is illustarted in the image below.

     //
     // 3       6        3       6
     //  \     /         |       |
     //   0===1      =   | 0   1 |
     //  /     \         |       |
     // 4       5        4-------5
     //
     OBCisTransStereo ct;
     ct.SetCenters(0, 1);
     ct.SetRefs(OBStereo::MakeRefs(3, 4, 5, 6), OBStereo::ShapeU);

     ct.IsTrans(3, 5); // true
     ct.IsTrans(3, 4); // false
     ct.IsTrans(3, 6); // false

     ct.IsCis(3, 6); // true
     ct.IsCis(3, 4); // false
     ct.IsCis(3, 5); // false

Since:
  version 2.3

## Constructor & Destructor Documentation

OBCisTransStereo | ( | OBMol * | mol | ) |

Constructor.

virtual ~OBCisTransStereo | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

OBStereo::Type GetType | ( | void |  | ) | const`[inline, virtual]`

Get the OBStereo::Type for this object.

Returns:
  OBStereo::CisTrans

Implements OBStereoBase.

bool IsValid | ( |  | ) | const

Returns:
  True if this object is valid. This object is valid if all these conditions are met:
  - `begin` != OBStereo::NoRef
  - `end` != OBStereo::NoRef
  - `refs` contains 4 elements

Referenced by OpenBabel::CanonicalLabels().

void SetConfig | ( | const Config & | config | ) |

Set the configuration using a Config struct.

Referenced by OpenBabel::CanonicalLabels().

Config GetConfig | ( | OBStereo::Shape | shape = `OBStereo::ShapeU` | ) | const

Get the configuration as Config struct.

Referenced by OpenBabel::CanonicalLabels(), and OBBuilder::CorrectStereoBonds().

Config GetConfig | ( | unsigned long | start,
|  | OBStereo::Shape | shape = `OBStereo::ShapeU`
| ) |  | const

Get the configuration as Config struct and ensure refs[0] is equal to `start`.

bool operator== | ( | const OBCisTransStereo & | other | ) | const

Compare the stereochemistry stored in the Config struct with the stereochemistry specified in the Config struct from `other`.

Equal to operator. Comparing OBCisTransStereo::Config structs is done using the information stored in the struct's data members (i.e. begin, end, refs and shape).

There are a number of cases resuling in false being returned:

- `begin` and `end` don't match (is checked using the 2 combinations)
- One of the Refs lists does not contain 4 elements.
- 2 or more OBStereo::ImplicitRef values in a single Config struct
- (The two `refs` don't share a single common element)

In the simplest case where both `refs` contain exactly the same elements (OBStereo::ContainsSameRefs()), coould include OBStereo::ImplicitRef), both Config struct are normalized to OBStereo::ShapeU starting with the same element. After this normalization, there are two possible orientations to overlay the shape on the double bond. From the illustration below, it can be seen only `refs`[2] has to be checked in order to conclude both Config structs have the same stereochemistry.

             1      4    1      4    1------4
              \    /     |      |           |
               C==C      |      |           |
              /    \     |      |           |
             2      3    2------3    2------3

                         1 2 3 4     1 2 3 4
                         |   |       |   |      <- in any case, refs[0] & refs[2] remain unchanged
                         1 2 3 4     1 4 3 2

When comparing a Config struct with explicit hydrogen(s) to one with implicit hydrogen(s), both `refs` are also normalized to OBStereo::ShapeU starting with the same common element. This shared element cannot be OBStereo::ImplicitRef. Depending on the position of the OBStereo::ImplicitRef element(s) in the `refs`, 3 cases are possible:

             refs[2] != OBStereo::ImplicitId:

               (analog to the case above where they contained the same elements )

               1 2 3 4
               |   |      <- refs[0] & refs[2] remain unchanged
               1 H 3 H

             else:

               1 2 3 4
               |     |    <- refs[0] & refs[3] remain unchanged
               1 H H 4

               1 2 3 4
               | |        <- refs[0] & refs[1] remain unchanged
               1 2 H H

In each case, the orientation of the U shape is also defined since there can be only one OBStereo::ImplicitRef for each side of the double bond.

Returns:
  True if both Config structs represent the stereochemistry.

bool operator!= | ( | const OBCisTransStereo & | other | ) | const`[inline]`

Not equal to operator. This is the inverse of the Equal to operator==.

Returns:
  True if the two Config structs represent a different stereochemistry.

OBGenericData* Clone | ( | OBBase * | mol | ) | const`[virtual]`

Reimplemented from OBGenericData.

bool IsOnSameAtom | ( | unsigned long | id1,
|  | unsigned long | id2
| ) |  | const

Check if the two atoms for `id1` & `id2` are bonded to the same atom. If the atoms for one of the atoms doesn't exist (anymore), the valence of the begin and end atom is checked. If the exising atom is bonded to the begin atom and end->GetValence() == 2, the ids are considered to be on different atoms. The reasoning behind this is that hydrogens may be deleted. However, you can also use OBStereo::ImplicitRef explicitly in code like:

     //
     //  F       F      F      F     0      3
     //   \     /       |      |     |      |
     //    C===C        | C  C |     | 1  2 |
     //   /     \       |      |     |      |
     // (H)     (H)    (H)----(H)    H------H
     //
     reading smiles F/C=C\F cis-difluorethene
     OBCisTransStereo ct(mol);
     ct.SetCenters(1, 2);
     ct.SetRefs(OBStereo::MakeRefs(0, OBStereo::ImplicitRef, OBStereo::ImplicitRef, 3));
     ...

Returns:
  True if `id1` and `id2` are bonded to the same atom taking implicit hydrogens into account.

bool IsTrans | ( | unsigned long | id1,
|  | unsigned long | id2
| ) |  | const

Returns:
  True if the two reference ids are placed trans configuration.

bool IsCis | ( | unsigned long | id1,
|  | unsigned long | id2
| ) |  | const

Returns:
  True if the two reference ids are placed in a cis configuration.

unsigned long GetTransRef | ( | unsigned long | id | ) | const

Get the reference id trans from reference `id`.

unsigned long GetCisRef | ( | unsigned long | id | ) | const

Get the reference id cis from reference `id`.

static ConfigType ToConfig | ( | const ConfigType & | cfg,
|  | unsigned long | start,
|  | OBStereo::Shape | shape = `OBStereo::ShapeU`
| ) |  | `[inline, static, inherited]`

OBMol* GetMolecule | ( |  | ) | const`[inline, inherited]`

Get the molecule. This can be used by subclasses when more information is needed (e.g. OBCisTransStereo::GetCisRef, ...).

void SetSpecified | ( | bool | specified | ) | `[inline, inherited]`

Set whether the stereochemistry is specified. Comparing a specified OBStereoBase derived class (or it's Config struct) with an unspecified one, always returns true.

bool IsSpecified | ( |  | ) | const`[inline, inherited]`

Returns:
  True if the stereochemistry is specified.

void SetAttribute | ( | const std::string & | v | ) | `[inline, inherited]`

Set the attribute (key), which can be used to retrieve this data.

Referenced by OBGastChrg::AssignPartialCharges(), OBMol::DoTransformations(), OBMol::FindLSSR(), OBMol::FindSSSR(), OBForceField::GetAtomTypes(), OBMol::GetFormula(), OBMol::GetLSSR(), OBForceField::GetPartialCharges(), OBMol::GetSSSR(), OBDescriptor::PredictAndSave(), and OBMol::SetFormula().

void SetOrigin | ( | const DataOrigin | s | ) | `[inline, inherited]`

Set the origin of this data, which can be used to filter the data.

Referenced by OBGastChrg::AssignPartialCharges(), OpenBabel::CalcSignedVolume(), OBMol::DoTransformations(), OBMol::FindAngles(), OBMol::FindLSSR(), OBMol::FindSSSR(), OBMol::FindTorsions(), OBMol::GetFormula(), OBMol::GetLSSR(), OBMol::GetSSSR(), OBDescriptor::PredictAndSave(), and OBMol::SetFormula().

virtual const std::string& GetAttribute | ( |  | ) | const`[inline, virtual, inherited]`

Returns:
  The attribute (key), which can be used to retrieve this data

Referenced by OBMoleculeFormat::MakeCombinedMolecule().

unsigned int GetDataType | ( |  | ) | const`[inline, inherited]`

Returns:
  the data type for this object as defined in OBGenericDataType

virtual const std::string& GetValue | ( |  | ) | const`[inline, virtual, inherited]`

Base class returns a default value (the attribute type) but should never be called.

Reimplemented in OBPairData, and OBCommentData.

Referenced by OBDepict::DrawMolecule(), OBDescriptor::FilterCompare(), and OBDescriptor::GetValues().

virtual DataOrigin GetOrigin | ( |  | ) | const`[inline, virtual, inherited]`

## Member Data Documentation

std::string _attr`[protected, inherited]`

attribute tag (e.g., "UnitCell", "Comment" or "Author")

Referenced by OBRotamerList::Clone(), and OBNasaThermoData::OBNasaThermoData().

unsigned int _type`[protected, inherited]`

attribute type -- declared for each subclass

Referenced by OBRotamerList::Clone(), and OBNasaThermoData::OBNasaThermoData().

DataOrigin _source`[protected, inherited]`

source of data for accounting

Referenced by OBConformerData::operator=(), OBSymmetryData::operator=(), OBTorsionData::operator=(), OBAngleData::operator=(), and OBChiralData::operator=().

The documentation for this class was generated from the following file:

- cistrans.h

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines